<template>
    <div>
        <md-toolbar class="md-accent main-navbar" md-elevation="1">
            <div class="md-toolbar-row md-layout md-alignment-top-center">
                <div class="md-layout-item md-xlarge-size-60 md-large-size-60 md-medium-size-90 md-small-size-95">
                    <!-- <div class="md-toolbar-section-start"> -->
                    <div class="md-toolbar mobil">
                        <a href="/app" class="">
                            <img :src="imgLogo" alt="logo" style="max-width: 140px" />
                        </a>
                        <!-- </div> -->

                        <!-- <div class="md-toolbar-section-end"> -->
                        <!-- Hide para mobile -->
                        <div class="md-small-hide md-layout md-alignment-top-right">
                            <div class="md-layout-item mr-0-5 md-size-35">
                                <md-field class="" md-inline>
                                    <label>Busqueda por palabra clave</label>
                                    <md-input v-model="searchWord"></md-input>
                                </md-field>
                            </div>
                            <div class="md-layout-item mr-0-5 md-size-15">
                                <md-field class="" md-inline>
                                    <label for="category">Categoría</label>
                                    <md-select name="category" class="input-custom" id="category" v-model="searchCategory">
                                        <md-option v-for="item in categories" v-bind:key="item.id" :value="item.id"> {{ item.label }}</md-option>
                                    </md-select>
                                </md-field>
                            </div>
                            <div class="md-layout-item mr-0-5 md-size-15">
                                <!-- <md-field class="" md-inline> -->
                                <!-- <label for="movie">Autordd</label> -->
                                <!-- <md-select name="movie" class="input-custom" id="aut" v-model="searchAuthor">
                                    <md-option v-for="author in authors" v-bind:key="author.id" :value="author.id">{{ author.username }}</md-option>
                                </md-select> -->
                                <!-- </md-field> -->
                                <md-autocomplete v-model="searchAuthor" :md-options="authors" md-layout="box" md-inline class="autocomplete-autor">
                                    <label>Autor</label>
                                </md-autocomplete>
                            </div>
                            <div class="md-layout-item md-size-5">
                                <md-button class="search-button mt-1" @click="Filter()">
                                    <md-icon>search</md-icon>
                                </md-button>
                            </div>
                        </div>
                        <!-- End hide for mobile -->

                        <!-- Menu for mobile -->
                        <div id="menu-mobile">
                            <md-button class="md-icon-button" @click="searchModal = true">
                                <md-icon>search</md-icon>
                            </md-button>
                            <md-button class="md-icon-button" @click="showSidepanel = true">
                                <md-icon>menu</md-icon>
                            </md-button>
                        </div>
                        <!-- End menu for mobile -->
                    </div>
                </div>
            </div>
        </md-toolbar>
        <md-drawer class="md-right menu-mobil" md-fixed :md-active.sync="showSidepanel">
            <md-toolbar id="toolbar-side-menu" class="md-transparent" md-elevation="0">
                <div v-if="user" class="author-card">
                    <md-avatar>
                        <img :src="user.profile.image_path" alt="Perfil" />
                    </md-avatar>

                    <div class="author-card-info">
                        <span>Hola</span>
                        <span
                            ><strong>{{ user.username }}</strong></span
                        >
                        <div class="author-card-links">
                            <a rel="noopener" @click.prevent="$auth.logout()" style="color: white"
                                >Cerrar sessión <md-icon style="color: white">login</md-icon></a
                            >
                        </div>
                    </div>
                </div>
                <div v-else>
                    <p style="color: white">¡BIENVENIDO!</p>
                </div>
            </md-toolbar>

            <md-list>
                <div v-if="user">
                    <md-list-item @click="toggleNavbarMobile()" to="/cuenta">
                        <div class="menu-popover">
                            <md-icon>account_circle</md-icon>
                            <span>Mi cuenta</span>
                        </div>
                    </md-list-item>
                    <md-list-item to="/in-recursos" @click="showSidepanel = false">
                        <div class="menu-popover">
                            <md-icon>format_list_bulleted</md-icon>
                            <span>Mis recursos</span>
                        </div>
                    </md-list-item>
                    <md-list-item to="/in-colecciones" @click="showSidepanel = false">
                        <div class="menu-popover">
                            <md-icon>collections</md-icon>
                            <span>Mis colecciones</span>
                        </div>
                    </md-list-item>
                    <md-list-item @click="toggleNavbarMobile()" to="/publicar-recurso">
                        <div class="menu-popover">
                            <md-icon>campaign</md-icon>
                            <span>Publica recurso</span>
                        </div>
                    </md-list-item>
                    <md-list-item @click="toggleNavbarMobile()" to="/publicar-coleccion">
                        <div class="menu-popover">
                            <md-icon>add_photo_alternate</md-icon>
                            <span>Crear colección</span>
                        </div>
                    </md-list-item>
                </div>
                <div v-else>
                    <md-list-item
                        @click="
                            toggleNavbarMobile();
                            loginModal = true;
                        "
                    >
                        <div class="menu-popover">
                            <md-icon>login</md-icon>
                            <span>Iniciar sesión</span>
                        </div>
                    </md-list-item>
                    <md-list-item
                        @click="
                            toggleNavbarMobile();
                            registerModal = true;
                        "
                    >
                        <div class="menu-popover">
                            <md-icon>person_add</md-icon>
                            <span>Registro</span>
                        </div>
                    </md-list-item>
                </div>
                <md-divider class="my-1"></md-divider>

                <md-list-item href="https://blog.paralideres.org/" target="_blank">
                    <div class="menu-popover">
                        <md-icon>edit</md-icon>
                        <span>Blog</span>
                    </div>
                </md-list-item>
                <md-list-item @click="toggleNavbarMobile()" to="/colecciones">
                    <div class="menu-popover">
                        <md-icon>collections</md-icon>
                        <span>Colecciones</span>
                    </div>
                </md-list-item>
                <md-list-item @click="toggleNavbarMobile()" to="/recursos">
                    <div class="menu-popover">
                        <md-icon>format_list_bulleted</md-icon>
                        <span>Recursos</span>
                    </div>
                </md-list-item>
            </md-list>
        </md-drawer>
        <!-- <div class="md-layout">
        <md-toolbar id="toolbar" md-elevation="0" class="md-transparent md-dense" :class="extraNavClasses" :color-on-scroll="colorOnScroll">
            <div class="md-toolbar-row md-collapse-lateral">
                <div class="md-toolbar-section-start">

                    <a href="/">
                        <img :src="imgLogo" style="max-width:140px" />
                    </a>
                </div>
                <div class="md-toolbar-section-end">
                    <md-button class="md-just-icon md-simple md-toolbar-toggle" :class="{ toggled: toggledClass }" @click="toggleNavbarMobile()">
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </md-button>

                    <div class="md-collapse">
                        <div class="md-collapse-wrapper">
                            <mobile-menu nav-mobile-section-start="false">

                            </mobile-menu>
                            <md-list class="md-list-section-end">
                                <md-list-item class="input-search">
                                    <md-field md-inline>
                                        <label>Palabras claves</label>
                                        <md-input></md-input>
                                    </md-field>
                                </md-list-item>

                                <md-list-item class="input-search">

                                    <md-field md-inline>
                                        <label for="category">Categoría</label>
                                        <md-select name="category" id="category">
                                            <md-option v-for="item in categories" v-bind:key="item.id" :value="item.id">
                                                {{item.label}}</md-option>
                                        </md-select>
                                    </md-field>

                                </md-list-item>
                                <md-list-item class="input-search">

                                    <md-field md-inline>
                                        <label for="movie">Autor</label>
                                        <md-select name="movie" id="movie">
                                            <md-option value="fight-club">Fight Club</md-option>
                                            <md-option value="godfather">Godfather</md-option>
                                            <md-option value="godfather-ii">Godfather II</md-option>
                                            <md-option value="godfather-iii">Godfather III</md-option>
                                            <md-option value="godfellas">Godfellas</md-option>
                                            <md-option value="pulp-fiction">Pulp Fiction</md-option>
                                            <md-option value="scarface">Scarface</md-option>
                                        </md-select>
                                    </md-field>

                                </md-list-item>
                                <md-list-item class="input-search">
                                    <md-button class="search-button">
                                        <md-icon>search</md-icon>
                                    </md-button>
                                </md-list-item>
                            </md-list>
                        </div>
                    </div>
                </div>
            </div>
        </md-toolbar>
    </div> -->
        <!-- <div class="md-layout"> -->
        <SecondaryNavbar class="md-small-hide" />
        <RegisterSection :showModal="registerModal" v-on:registerModalHide="registerModalHide" />
        <LoginSection :showModal="loginModal" v-on:loginModalHide="loginModalHide" />

        <SearchSeccion :showModal="searchModal" v-on:searchModalHide="searchModalHide" />
        <!-- </div> -->
    </div>
</template>

<script>
let resizeTimeout;
import axios from 'axios';

function resizeThrottler(actualResizeHandler) {
    // ignore resize events as long as an actualResizeHandler execution is in the queue
    if (!resizeTimeout) {
        resizeTimeout = setTimeout(() => {
            resizeTimeout = null;
            actualResizeHandler();

            // The actualResizeHandler will execute at a rate of 15fps
        }, 66);
    }
}

import MobileMenu from '../layout/MobileMenu';
import SecondaryNavbar from './SecondaryNavbar';
import RegisterSection from '../views/components/RegisterSection';
import LoginSection from '../views/components/LoginSection';
import SearchSeccion from '../views/components/SearchSeccion';

export default {
    components: {
        MobileMenu,
        SecondaryNavbar,
        RegisterSection,
        LoginSection,
        SearchSeccion
    },
    props: {
        type: {
            type: String,
            default: 'white',
            validator(value) {
                return ['white', 'default', 'primary', 'danger', 'success', 'warning', 'info'].includes(value);
            }
        },
        colorOnScroll: {
            type: Number,
            default: 0
        }
    },
    data() {
        return {
            selectedAuthor: '',
            searchWord: '',
            searchAuthor: '',
            searchCategory: 0,
            search: {},
            extraNavClasses: '',
            toggledClass: false,
            imgLogo: require('../assets/img/PL_ÍCONOS-102.png'),
            categoriesEndPoint: '/api/categories',
            authorsEndPoint: '/api/authors',
            authorsSlugEndPoint: '/api/searchAuthor?slug=',
            categories: [],
            authors: [],
            authorsAll: [],
            showSidepanel: false,
            registerModal: false,
            loginModal: false,
            searchModal: false
        };
    },
    computed: {
        showDownload() {
            const excludedRoutes = ['login', 'landing', 'profile'];
            return excludedRoutes.every((r) => r !== this.$route.name);
        },
        user() {
            return this.$auth?.watch?.data;
        }
    },
    watch: {
        searchAuthor() {
            this.getAuthorsSlug();
        }
    },
    methods: {
        getAuthorsSlug() {
            axios
                .get(this.authorsSlugEndPoint + this.searchAuthor)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.authorsAll = res.data.data;
                        this.authors = res.data.data.map((autor) => autor.username);
                    } else {
                        this.authors = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getAuthorsSlug' + error);
                });
        },
        getCategories() {
            axios
                .get(this.categoriesEndPoint)
                .then((res) => {
                    if (res && res.data && res.data.categories) {
                        this.categories = res.data.categories;
                    } else {
                        this.categories = [];
                    }
                })
                .catch((error) => {
                    console.log('Error GetCategories' + error);
                });
        },
        getAuthors() {
            axios
                .get(this.authorsEndPoint)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.authors = res.data.data;
                    } else {
                        this.authors = [];
                    }
                })
                .catch((error) => {
                    console.log('Error GetAuthors' + error);
                });
        },
        registerModalHide(event) {
            this.registerModal = false;
        },
        loginModalHide(event) {
            this.loginModal = false;
        },
        searchModalHide(event) {
            this.searchModal = false;
        },
        bodyClick() {
            let bodyClick = document.getElementById('bodyClick');

            if (bodyClick === null) {
                let body = document.querySelector('body');
                let elem = document.crateElement('div');
                elem.setAttribute('id', 'bodyClick');
                body.appendChild(elem);

                let bodyClick = document.getElementById('bodyClick');
                bodyClick.addEventListener('click', this.toggleNavbarMobile);
            } else {
                bodyClick.remove();
            }
        },
        toggleNavbarMobile() {
            // this.NavbarStore.showNavbar = !this.NavbarStore.showNavbar;
            // this.toggledClass = !this.toggledClass;
            // this.bodyClick();
            this.showSidepanel = false;
        },
        handleScroll() {
            let scrollValue = document.body.scrollTop || document.documentElement.scrollTop;
            let navbarColor = document.getElementById('toolbar');
            this.currentScrollValue = scrollValue;
            //   if (this.colorOnScroll > 0 && scrollValue > this.colorOnScroll) {
            //     this.extraNavClasses = `md-${this.type}`;
            //     navbarColor.classList.remove("md-transparent");
            //   } else {
            //     if (this.extraNavClasses) {
            //       this.extraNavClasses = "";
            //       navbarColor.classList.add("md-transparent");
            //     }
            //   }
        },
        scrollListener() {
            resizeThrottler(this.handleScroll);
        },
        scrollToElement() {
            let element_id = document.getElementById('downloadSection');
            if (element_id) {
                element_id.scrollIntoView({
                    block: 'end',
                    behavior: 'smooth'
                });
            }
        },
        Filter() {
            const author_id = this.authorsAll.find((element) => element.username == this.searchAuthor);
            this.$router.replace({
                name: 'resources',
                query: {
                    title: this.searchWord,
                    category_id: this.searchCategory,
                    author_id: author_id ? author_id.id : null
                }
            });
        },
        validateQueryParams() {
            const query = this.$route.query;

            if (query) {
                if (query.title || query.category_id || query.author_id) {
                    this.searchWord = query.title;
                    this.searchCategory = query.category_id;
                    this.searchAuthor = query.author_id;
                }
            }
        }
    },
    mounted() {
        document.addEventListener('scroll', this.scrollListener);
        this.getCategories();
        // this.getAuthors();
        this.validateQueryParams();
    },
    beforeDestroy() {
        document.removeEventListener('scroll', this.scrollListener);
    }
};
</script>

<style lang="scss" scoped>
.md-field .md-input,
.md-field .md-textarea {
    background-color: white !important;
}

.md-field.md-theme-default .md-helper-text,
.md-field.md-theme-default .md-count,
.md-field.md-theme-default label {
    color: rgba(0, 0, 0, 0.54);
    margin-left: 4px !important;
}

.autocomplete-autor {
    background-color: white !important;
}
.md-toolbar .md-autocomplete.md-theme-default.md-autocomplete-box label,
.md-toolbar .md-autocomplete.md-theme-default.md-autocomplete-box input {
    -webkit-text-fill-color: rgba(0, 0, 0, 0.54);
    left: 0px;
}

.md-toolbar .md-field.md-inline.md-autocomplete-box {
    min-height: 32px;
    height: 32px;
    margin-top: 17px;
}

.input-custom {
    background-color: white !important;
}

#toolbar-side-menu {
    background-color: #363c44 !important;
}
.menu-mobil {
    // width: 60%;
}
.mobil {
    display: flex;
    justify-content: space-between;
}
.author-card {
    padding: 16px 0px;
    display: flex;
    align-items: center;
    background-color: #363c44 !important; //gray-light
    color: white;
    margin-top: -8px;

    .md-avatar {
        margin-right: 16px;
    }

    .author-card-info {
        display: flex;
        flex-flow: column;
        flex: 1;
    }

    span {
        font-size: 14px;
    }

    .author-card-links {
        display: flex;

        a + a {
            margin-left: 8px;
        }
    }
}
</style>
